/*******************************************************************************
* Copyright 2015-2021 Intel Corporation.
*
* This software and the related documents are Intel copyrighted  materials,  and
* your use of  them is  governed by the  express license  under which  they were
* provided to you (License).  Unless the License provides otherwise, you may not
* use, modify, copy, publish, distribute,  disclose or transmit this software or
* the related documents without Intel's prior written permission.
*
* This software and the related documents  are provided as  is,  with no express
* or implied  warranties,  other  than those  that are  expressly stated  in the
* License.
*******************************************************************************/

#include <stdio.h>
#include "ipp.h"

/* Next two defines are created to simplify code reading and understanding */
#define EXIT_MAIN exitLine:                                  /* Label for Exit */
#define check_sts(st) if((st) != ippStsNoErr) goto exitLine; /* Go to Exit if Intel(R) Integrated Primitives (Intel(R) IPP) function returned status different from ippStsNoErr */

/* Results of ippMalloc() are not validated because Intel(R) IPP functions perform bad arguments check and will return an appropriate status  */

int main()
{
    Ipp16u pVals[] = { 12, 6, 78 };
    Ipp16u pTable[] = { 1, 3, 5, 7, 18, 24, 35, 48 };
    Ipp16u pOutVals[3];
    int pOutIndexes[3];
    IppStatus status;
    int i;

    printf("Source table\n");
    for (i = 0; i < 8; i++) printf("%d ", pTable[i]);
    printf("\nSource vector\n");
    for (i = 0; i < 3; i++) printf("%d ", pVals[i]);

    check_sts(status = ippsFindNearest_16u(pVals, pOutVals, pOutIndexes, 3, pTable, 8));

    printf("\nResult values vector\n");
    for (i = 0; i < 3; i++) printf("%d ", pOutVals[i]);

    printf("\nResult indexes vector\n");
    for (i = 0; i < 3; i++) printf("%d ", pOutIndexes[i]);

EXIT_MAIN
    printf("\nExit status %d (%s)\n", (int)status, ippGetStatusString(status));
    return (int)status;
}