/*******************************************************************************
* Copyright 2017-2021 Intel Corporation.
*
* This software and the related documents are Intel copyrighted  materials,  and
* your use of  them is  governed by the  express license  under which  they were
* provided to you (License).  Unless the License provides otherwise, you may not
* use, modify, copy, publish, distribute,  disclose or transmit this software or
* the related documents without Intel's prior written permission.
*
* This software and the related documents  are provided as  is,  with no express
* or implied  warranties,  other  than those  that are  expressly stated  in the
* License.
*******************************************************************************/

#include <stdio.h>
#include "ipp.h"

/* Next two defines are created to simplify code reading and understanding */
#define EXIT_MAIN exitLine:                                  /* Label for Exit */
#define check_sts(st) if((st) != ippStsNoErr) goto exitLine; /* Go to Exit if Intel(R) Integrated Primitives (Intel(R) IPP) function returned status different from ippStsNoErr */

/* Results of ippMalloc() are not validated because Intel(R) IPP functions perform bad arguments check and will return an appropriate status  */

int main()
{
    Ipp32fc pSrc[5] = { { 1.2, 3.2 }, { 0.0, 0.3 }, { 4.3, 6.7 }, { 4.2, 0.0 }, { 1.2, 1.2 } };
    Ipp32f pDstIm[5];
    IppStatus status;
    int i;

    printf("\nSource vector\n");
    for (i = 0; i < 5; i++) printf("%.1f, %.1f; ", pSrc[i].re, pSrc[i].im);

    check_sts(status = ippsMagnitude_32fc(pSrc, pDstIm, 5));

    printf("\nResult values vector\n");
    for (i = 0; i < 5; i++) printf("%.1f ", pDstIm[i]);

EXIT_MAIN
    printf("\nExit status %d (%s)\n", (int)status, ippGetStatusString(status));
    return (int)status;
}
